# N-gram generator based on nltk module
# K-most frequent words in a class of tweets
import nltk
import operator # for sorting dictionaries

# getting word frequencies from training data for a given class

def getTweetWords(tweet):
    all_words = []
    sTweet = tweet.split()
    return sTweet

def getWordFeatures(wordlist): # from a list of words returns a dictionary with word, freq as key, value
    wordlist = nltk.FreqDist(wordlist)
    result=[]
    for k in wordlist.keys():
        result.append([k,wordlist[k]])
    return result

def ngramText(filename): # generate vector of n-grams in text file
    textWords = []
    f = open(filename, "rb")
    line = f.readline()
    while line:
        line = str(line)
         # since after reading in binary data and converting it into a string the line looks like:
         # b'"4","3","Mon May 11 03:17:40 UTC 2009","kindle2","tpryan","@stellargirl I loooooooovvvvvveee my Kindle2. Not that the DX is cool, but the 2 is fantastic in its own right."\n'
         # therefore start at pos 3 and end 3 chars before the end 
        line = line[2:-3]
        textWords.extend(getTweetWords(line))
        line = f.readline()
    f.close()
    return textWords

def sortList(x):
    return list(reversed(sorted(x, key=operator.itemgetter(1))))

def mostFreqList(filename,k): # extract k most frequent words from the sorted list
    d = getWordFeatures(ngramText(filename))
    l = sortList(d)
    m = [w[0] for w in l[0:k]]
    return m


#filename="../data/positive_processed.csv"
